package cn.com.infosec.asn1.cryptopro;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import java.math.BigInteger;
import java.util.Enumeration;

public class GOST3410ParamSetParameters extends ASN1Encodable {
   int keySize;
   DERInteger p;
   DERInteger q;
   DERInteger a;

   public static GOST3410ParamSetParameters getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(ASN1Sequence.getInstance(obj, explicit));
   }

   public static GOST3410ParamSetParameters getInstance(Object obj) {
      if (obj != null && !(obj instanceof GOST3410ParamSetParameters)) {
         if (obj instanceof ASN1Sequence) {
            return new GOST3410ParamSetParameters((ASN1Sequence)obj);
         } else {
            throw new IllegalArgumentException("Invalid GOST3410Parameter: " + obj.getClass().getName());
         }
      } else {
         return (GOST3410ParamSetParameters)obj;
      }
   }

   public GOST3410ParamSetParameters(int keySize, BigInteger p, BigInteger q, BigInteger a) {
      GOST3410ParamSetParameters var10000 = this;
      GOST3410ParamSetParameters var10001 = this;
      GOST3410ParamSetParameters var10002 = this;
      super();
      this.keySize = keySize;
      DERInteger var5;
      var5 = new DERInteger.<init>(p);
      var10002.p = var5;
      var5 = new DERInteger.<init>(q);
      var10001.q = var5;
      var5 = new DERInteger.<init>(a);
      var10000.a = var5;
   }

   public GOST3410ParamSetParameters(ASN1Sequence seq) {
      GOST3410ParamSetParameters var10000 = this;
      GOST3410ParamSetParameters var10001 = this;
      GOST3410ParamSetParameters var10002 = this;
      super();
      Enumeration var2;
      this.keySize = ((DERInteger)(var2 = seq.getObjects()).nextElement()).getValue().intValue();
      var10002.p = (DERInteger)var2.nextElement();
      var10001.q = (DERInteger)var2.nextElement();
      var10000.a = (DERInteger)var2.nextElement();
   }

   /** @deprecated */
   public int getLKeySize() {
      return this.keySize;
   }

   public int getKeySize() {
      return this.keySize;
   }

   public BigInteger getP() {
      return this.p.getPositiveValue();
   }

   public BigInteger getQ() {
      return this.q.getPositiveValue();
   }

   public BigInteger getA() {
      return this.a.getPositiveValue();
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(new DERInteger(this.keySize));
      var1.add(this.p);
      var1.add(this.q);
      var10000.add(this.a);
      return new DERSequence(var1);
   }
}
